import java.io.IOException;
import java.math.*;
import java.sql.*;
import java.util.*;
import org.dom4j.*;

import com.justep.system.data.*;
import com.justep.system.context.*;
import com.justep.system.util.*;
import com.justep.util.Utils;
import com.justep.system.util.*;
import com.sun.org.apache.xml.internal.security.utils.Base64;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.net.*;
import java.awt.Toolkit;
import java.awt.datatransfer.*;
// java.awt.datatransfer;
//java.awt.datatransfer.Clipboard

import javax.naming.NamingException;

public class Scj {

	// 取得登陆者信息
	public static Table queryLoginUserInfo() {
		Map<String, Object> params = new HashMap<String, Object>();
		//params.put("XM", ContextHelper.getOperator().getName());
		//params.put("IPDZ", ContextHelper.getLoginIP());
		params.put("XM", "system");
		params.put("IPDZ", "192.168.1.113");
		String sql = "select a.STBH,a.SBZCH,b.STMC,:XM as XM from ST_ZCXX a " + " optional join ST_STJBXX b  on a.STBH = b.STBH " + " where a.IPDZ = :IPDZ";
		Table loginTable = KSQL.select(sql, params, "/BJBusWYST/scj/data", null);
		return loginTable;
	}

	// 取得“员工信息”页面的数据
	public static Table queryPersonInfo(String YGKXPXLH) {
		Map<String, Object> params = new HashMap<String, Object>();
		params.put("YGKXPXLH", YGKXPXLH);
		String ksql = "select a.GMSFHM,a.KPYE,c.YGKH,c.XM,c.SZBM,d.CODEVAULE as KPZT,e.CODEVAULE as KPLB,0 as CZJE,a.KPYE as CHYE " + " from ZH_KPXX a "
				+ " optional join ZH_RYKPJL b on b.GMSFHM = a.GMSFHM and b.YGKXPXLH = a.YGKXPXLH" 
				+ " optional join ZH_RYDAXX c on c.GMSFHM = a.GMSFHM "
				+ " optional join SA_ZD d on d.CONDIATION = a.KPZT and d.CODENAME = '卡片状态' " 
				+ " optional join SA_ZD e on e.CONDIATION = b.KPLX and e.CODENAME = '卡片类别' " 
				+ " where a.YGKXPXLH = :YGKXPXLH";
		Table kpxxTable = KSQL.select(ksql, params, "/BJBusWYST/scj/data", null);
		System.out.println(ksql);
		return kpxxTable;
	}

	// 根据当前时间取得餐次
	public static String getMealTime(String stbh) {
		Map<String, Object> mapParam = new HashMap<String, Object>();
		mapParam.put("time", CommonUtils.getCurrentTime());
		mapParam.put("stbh", stbh);

		String sql = "select a.CC from DC_STCC a where a.STBH = :stbh and a.DCQSSJ <= :time and a.DCJSSJ >= :time";
		Table stccTable = KSQL.select(sql, mapParam, "/BJBusWYST/scj/data", null);
		String stcc = "";
		Iterator<Row> rows = stccTable.iterator();
		while (rows.hasNext()) {
			Row row = rows.next();
			stcc = row.getValue("CC").toString();
			break;
		}
		return stcc;
	}

	// 取得“紧急售餐”页面的一览信息
	public static Table queryMenuList(String STBH, String CC) {
		Table cdjbxxTable = null;
		// 取得某日某食堂的所有菜单编号
		Map<String, Object> params1 = new HashMap<String, Object>();
		params1.put("STBH", STBH);
		params1.put("RQ", CommonUtils.getCurrentDate());
		params1.put("CC", CC);
		String ksql = "select a.* from DC_MRCDXX a where a.STBH = :STBH AND a.RQ = :RQ AND a.CC = :CC";
		Table mrcdxxTable = KSQL.select(ksql, params1, "/BJBusWYST/scj/data", null);
		if(mrcdxxTable!=null && mrcdxxTable.size() > 0)
		{
			// 将所有菜单编号转成一定格式的字符串
			Map<String, String[]> hashMap = new HashMap<String, String[]>();
			String cdnr = mrcdxxTable.iterator().next().getString("CDNR");
			if(cdnr !=null && !cdnr.trim().isEmpty()){
				String[] cdnrAllArr = cdnr.trim().split(";");
				String cdnrStr = "(";
				for (int i = 0; i < cdnrAllArr.length; i++) {
					String[] cdnrArr = cdnrAllArr[i].split("#");
					hashMap.put(cdnrArr[1], cdnrArr);
		
					cdnrStr += "'" + cdnrArr[1] + "'";
					if (i < cdnrAllArr.length - 1) {
						cdnrStr += ",";
					}
				}
				cdnrStr += ")";
		
				// 取得某日某食堂的所有菜单详细
				Map<String, Object> params2 = new HashMap<String, Object>();
				params2.put("STBH", STBH);
				String ksq2 = "select b,b.STBH,b.CPBH,b.CPMC,b.TP,'' as TPSTR,b.JG,0 AS FS from DC_CDJBXX b where b.STBH = :STBH AND b.CPBH IN " + cdnrStr;
				cdjbxxTable = KSQL.select(ksq2, params2, "/BJBusWYST/scj/data", null);
			}
		}
		
		//将图片解析成base64string
		Iterator<Row> rows = cdjbxxTable.iterator();
		while (rows.hasNext()) {
			Row row = rows.next();			
			java.sql.Blob tpBlob = row.getBlob("TP");
			if(tpBlob!=null)
			{
				try {
					String tpStr =  Base64.encode(tpBlob.getBytes((long)1, (int)tpBlob.length()));
					row.setValue("TPSTR", tpStr);
					System.out.println("开始"+tpStr+"结束");
				} catch (SQLException e) {
					e.printStackTrace();
				}	
			}		
		}

		// 返回菜单详细表
		return cdjbxxTable;
	}

	// 我的订单
	public static Table getMyOrderList(String stbh,String xph,String ddzt){
		Map<String, Object> params = new HashMap<String, Object>();
		params.put("STBH", stbh);
		params.put("YGKXPXLH", xph);
		params.put("DDZT", ddzt);
		String sql = "select a.DDBH,a.XM,b.CODEVAULE as DDLX,a.XDSJ,a.XFZE,c.CODEVAULE as DDZT,d.CODEVAULE as DCCC,e.CODEVAULE as KKZT,a.SCSJ,a.SCLXFS,a.SCDD,g.CODEVAULE as KPZT " + 
				  " from DC_DD a " + 
				  " optional join SA_ZD b on b.CONDIATION = a.DDLX and b.CODENAME = '用餐类型' " + 
				  " optional join SA_ZD c on c.CONDIATION = a.DDZT and c.CODENAME = '订单状态' " + 
				  " optional join SA_ZD d on d.CONDIATION = a.DCCC and d.CODENAME = '餐次' " + 
				  " optional join SA_ZD e on e.CONDIATION = a.KKZT and e.CODENAME = '扣款状态' " + 
				  " optional join ZH_KPXX f on f.YGKXPXLH = a.YGKXPXLH " + 
				  " optional join SA_ZD g on g.CONDIATION = f.KPZT and g.CODENAME = '卡片状态' " +
				  " where 1=1";
		if (stbh != null && !stbh.trim().isEmpty()) {
			sql += " and a.STBH = :STBH ";
		}
		if (xph != null && !xph.trim().isEmpty()) {
			sql += " and a.YGKXPXLH = :YGKXPXLH ";
		}
		if (ddzt != null && !ddzt.trim().isEmpty()) {
			sql += " and a.DDZT = :DDZT ";
		}
		Table ddTable = KSQL.select(sql, params, "/BJBusWYST/scj/data", null);		
		return ddTable;
	}

	// 取得订单编号
	public static String getNewOrderId(String mealTime) {
		String maxOrderId = "";
		SimpleDateFormat sDateFormat = new SimpleDateFormat("yyyyMMdd");
		String maxOrderIdPre = sDateFormat.format(new java.util.Date());
		Map<String, Object> mapParam = new HashMap<String, Object>();
		mapParam.put("orderIdPre", maxOrderIdPre + mealTime);
		String sql = "select max(a.DDBH) as seq from DC_DD a where substring(a.DDBH,1,9) = :orderIdPre";
		Table orderTable = KSQL.select(sql, mapParam, "/BJBusWYST/scj/data", null);

		Iterator<Row> rows = orderTable.iterator();
		while (rows.hasNext()) {
			Row row = rows.next();
			maxOrderId = row.getValue("seq") == null ? "0" : row.getValue("seq").toString();
			break;
		}

		String orderIdSuf = maxOrderId == "0" ? "0" :maxOrderId.substring(9, maxOrderId.length());
		String orderId = maxOrderIdPre + mealTime + String.format("%07d", Integer.parseInt(orderIdSuf) + 1);
		return orderId;
		// return BizUtils.createNextSequenceString(orderIdPre+mealTime,"0000000");
	}

	// 设置订单状态=取餐
	public static int updateOrderStatus(String DDBH) {
		Map<String, Object> map = new HashMap<String, Object>();
		map.put("DDBH", DDBH);
		String sql = "UPDATE DC_DD a SET a.DDZT='0' WHERE a.DDBH= :DDBH ";
		return KSQL.executeUpdate(sql, map, "/BJBusWYST/scj/data", null);
	}

	// 订单查询，取得订单一览表
	public static Table queryOrderList(String cardId, java.sql.Date orderDate, String mealType, String orderStatus, String mealTime, String orderId, String stbh) {
		Map<String, Object> params = new HashMap<String, Object>();
		params.put("STBH", stbh);
		params.put("cardId", cardId);
		params.put("orderDate", orderDate);
		params.put("mealType", mealType);
		params.put("orderStatus", orderStatus);
		params.put("mealTime", mealTime);
		params.put("orderId", orderId);

		String sql = "select a.DDBH,a.XDSJ,a.XM from DC_DD a " 
		+ " optional join ZH_KPXX b on b.YGKXPXLH = a.YGKXPXLH and b.KPZT = '0'" 
		+ " optional join ZH_RYDAXX c on c.GMSFHM = b.GMSFHM" 
		+ " where a.STBH = :STBH and substring(a.XDSJ,1,10) = :orderDate";
		if (cardId != null && !cardId.trim().isEmpty()) {
			sql += " and (c.YGKH=:cardId or b.GMSFHM=:cardId ) ";
		}
		if (mealType != null && !mealType.trim().isEmpty()) {
			sql += " and a.DDLX=:mealType ";
		}
		if (orderStatus != null && !orderStatus.trim().isEmpty()) {
			sql += " and a.DDZT=:orderStatus ";
		}
		if (mealTime != null && !mealTime.trim().isEmpty()) {
			sql += " and a.DCCC=:mealTime";
		}
		if (orderId != null && !orderId.trim().isEmpty()) {
			sql += " and a.DDBH=:orderId ";
		}
		Table ddbTable = KSQL.select(sql, params, "/BJBusWYST/scj/data", null);
		return ddbTable;
	}

	/*
	 * //判断字符串是否为空 private bool isNotEmpty(String str) { bool bl = true; if(str
	 * ==null || str.trim().isEmpty()){ bl = false; } return bl; }
	 */

	// 订单查询，取得订单详情
	public static Table queryOrderDetail(String orderId) {
		Map<String, Object> params = new HashMap<String, Object>();
		params.put("DDBH", orderId);
		String sql = "select distinct concat(a.DDBH,b.CPBH) as fID, a.DDBH,d.CODEVAULE as DCCC,a.XDSJ,a.XM,a.SCDD,a.XFZE,b.CPMC,b.SL,c.CODEVAULE as DDZT,e.CODEVAULE as DDLX " + 
				  " from DC_DD a " + 
				  " optional join DC_DDMX b on b.DDBH = a.DDBH " + 
				  " optional join SA_ZD c on c.CONDIATION = a.DDZT and c.CODENAME = '订单状态' " + 
				  " optional join SA_ZD d on d.CONDIATION = a.DCCC and d.CODENAME = '餐次' " + 
				  " optional join SA_ZD e on e.CONDIATION = a.DCCC and e.CODENAME = '用餐类型' " + 
				  " where a.DDBH = :DDBH";
		Table ddbTable = KSQL.select(sql, params, "/BJBusWYST/scj/data", null);
		return ddbTable;
	}

	// 充值卡查询，充值卡详情
	public static Table queryCardDetail(String idCode, String cardCode, String name) {
		Map<String, Object> params = new HashMap<String, Object>();
		params.put("GMSFHM", idCode);
		params.put("YGKH", cardCode);
		params.put("XM", name);

		String sql = "select b.YGKH,a.KPYE,b.XM,b.SZGW,b.SZBM,b.SZDW,c.CODEVAULE as KPZT " + 
				  " from ZH_KPXX a " + 
				  " optional join ZH_RYDAXX b on b.GMSFHM = a.GMSFHM " + 
				  " optional join SA_ZD c on c.CONDIATION = a.KPZT and c.CODENAME = '卡片状态' " + 
				  " where 1=1";
		if (idCode != null && !idCode.trim().isEmpty()) {
			sql += " and a.GMSFHM = :GMSFHM ";
		}
		if (cardCode != null && !cardCode.trim().isEmpty()) {
			sql += " and a.YGKH = :YGKH ";
		}
		if (name != null && !name.trim().isEmpty()) {
			sql += " and b.XM like concat('%',:XM,'%')";
		}

		Table ddbTable = KSQL.select(sql, params, "/BJBusWYST/scj/data", null);
		return ddbTable;
	}

	// 取得新流水号
	public static String getNewLsh(String lshPre){
		String maxLsh = "";
		SimpleDateFormat sDateFormat = new SimpleDateFormat("MMdd");
		String maxLshPre = lshPre + sDateFormat.format(new java.util.Date());
		Integer lshPreLen = maxLshPre.length();
		
		Map<String, Object> mapParam = new HashMap<String, Object>();
		mapParam.put("ZDJYLSH", maxLshPre);
		mapParam.put("lshPreLen", lshPreLen);
		String sql = "select max(a.ZDJYLSH) as ZDJYLSH from ZH_XFLS a where substring(a.ZDJYLSH,1,:lshPreLen) = :ZDJYLSH";
		Table xflsTable = KSQL.select(sql, mapParam, "/BJBusWYST/scj/data", null);

		Iterator<Row> rows = xflsTable.iterator();
		while (rows.hasNext()) {
			Row row = rows.next();
			maxLsh = row.getValue("ZDJYLSH") == null ? "0" : row.getValue("ZDJYLSH").toString();
			break;
		}

		String lshSuf = maxLsh == "0" ? "0" :maxLsh.substring(lshPreLen, maxLsh.length());
		String lsh = maxLshPre + String.format("%06d", Integer.parseInt(lshSuf) + 1);
		return lsh;		
	}
}