import java.math.BigDecimal;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.naming.NamingException;

import com.justep.model.ModelUtils;
import com.justep.system.data.KSQL;
import com.justep.system.data.ModifyState;
import com.justep.system.data.Row;
import com.justep.system.data.Table;
import com.sync.SyncHandler;
//import com.sync.SyncHandler;


public class Zh {
	public static int saveVIEW_CZKGL(List insertRange,List deleteRange,List updateRange,String concept,String dataModel,String fnModel,String readOnly,String notNull,Table table) throws NamingException, SQLException{
		
		//获取JDBC的连接并开始事务（***注意如果 不能处理异常就要捕获异常）
		Connection conn =	ModelUtils.getConnectionInTransaction("/BJBusWYST/zh/data");
//		System.out.println("进入了视图！循环");
		Iterator<Row> rows = table.iterator();
		while (rows.hasNext()) {
			Row row = rows.next();
			ModifyState rowState = row.getState();
			String XM = row.getString("XM");
			String GMSFHM = row.getString("GMSFHM");
			String YGKH = row.getString("YGKH");
			Integer KPZT = row.getInteger("KPZT");
			Integer KPLX = row.getInteger("KPLX");
			BigDecimal KPYE = row.getDecimal("KPYE");
			String SZDW = row.getString("SZDW");
			String SZBM = row.getString("SZBM");
			String YGKXPXLH = row.getString("YGKXPXLH");
			
			if (ModifyState.EDIT.equals(rowState)) {
				updateRYDAXX(conn, XM, GMSFHM, YGKH, SZDW,SZBM);
				updateRYKPJL(conn, YGKXPXLH, YGKH,KPZT,KPLX);
				updateKPXX(conn,YGKXPXLH,KPYE);
			} 
		}
		
		return table.size();
		
	}
	
	com.justep.system.data.Transaction tx = null;
	//更新人员档案信息表
	private static void updateRYDAXX(Connection conn, String XM, String GMSFHM, String YGKH,String SZDW,String SZBM) throws SQLException {
		PreparedStatement pstmt = conn.prepareStatement("update ZH_RYDAXX set XM = ?,YGKH = ? ,SZDW = ?,SZBM = ? where  GMSFHM = ? ");
		try {
			pstmt.setString(1, XM);
			pstmt.setString(2, YGKH);
			pstmt.setString(3, SZDW);
			pstmt.setString(4, SZBM);
			pstmt.setString(5, GMSFHM);
			
			if (pstmt.executeUpdate() != 1) {
				throw new SQLException("更新YGDAXX失败，GMSFHM = " + GMSFHM);
			}
		}catch (SQLException e) {
		    //手工回滚事务或者抛出异常都可以
		    //ContextHelper.getTransaction().rollback();
		    throw new RuntimeException(e);
		} finally {
			 try {
	                if (pstmt != null) {
	                        pstmt.close();
	                }
	        } catch (SQLException e) {
	                        System.out.println("##close.SQLException");
	        }
		}
		
		
	}	
	
	//更行人员卡片记录表
	private static void updateRYKPJL(Connection conn, String YGKXPXLH, String YGKH,Integer KPZT,Integer KPLX) throws SQLException {
		PreparedStatement pstmt = conn.prepareStatement("update ZH_RYKPJL set YGKH = ?,KPZT = ? ,KPLX = ? where  YGKXPXLH = ?");
		try {
			pstmt.setString(1, YGKH);
			pstmt.setInt(2, KPZT);
			pstmt.setInt(3, KPLX);
			pstmt.setString(4, YGKXPXLH);

			if (pstmt.executeUpdate() != 1) {
				throw new SQLException("更新RYDAJL失败，YGKXPXLH = " + YGKXPXLH );
			}
		}catch (SQLException e) {
		    //手工回滚事务或者抛出异常都可以
		    //ContextHelper.getTransaction().rollback();
		    throw new RuntimeException(e);
		} finally {
			 try {
		            if (pstmt != null) {
		                    pstmt.close();
		            }
		    } catch (SQLException e) {
		                    System.out.println("##close.SQLException");
		    }
		}
	}	
	
	//更新卡片信息表
	private static void updateKPXX(Connection conn ,String YGKXPXLH,BigDecimal KPYE) throws SQLException {
		PreparedStatement pstmt = conn.prepareStatement("update ZH_KPXX set KPYE = ? where YGKXPXLH = ?");
		try {
			pstmt.setBigDecimal(1, KPYE);
			pstmt.setString(2, YGKXPXLH);

			if (pstmt.executeUpdate() != 1) {
				throw new SQLException("更新KPXX失败，YGKXPXLH = " + YGKXPXLH );
			}
		}catch (SQLException e) {
		    //手工回滚事务或者抛出异常都可以
		    //ContextHelper.getTransaction().rollback();
		    throw new RuntimeException(e);
		} finally {
			 try {
		            if (pstmt != null) {
		                    pstmt.close();
		            }
			 } catch (SQLException e) {
	                    System.out.println("##close.SQLException");
	    }
}
		
//		String res = SyncHandler.doSync("canteenBasicInfoDownSyn", "{'STJBXX':[{'STBH','001'},{'STBH','002'}]}");
//		System.out.println(res);
	}	
	
	private static void updateRYDAXX2 (Connection conn ,String GMSFHM,String RYFL,String RYLB,String RYBH,String YGKH,String XM,String XMJP,String GWMC,String XB,String SZDW,String SZGW,String SZBM,String MZ,String ZT) throws SQLException{
		PreparedStatement pstmt = conn.prepareStatement("update ZH_RYDAXX set RYFL = ?,RYLB =  ?,RYBH = ?,YGKH = ?,XM = ?,XMJP = ?,GWMC = ?,XB = ?,SZDW = ?,SZGW = ?,SZBM = ?,MZ = ?,ZT = ? where GMSFHM = ?");
		try{
			pstmt.setString(1, RYFL);
			pstmt.setString(2, RYLB);
			pstmt.setString(3, RYBH);
			pstmt.setString(4, YGKH);
			pstmt.setString(5, XM);
			pstmt.setString(6, XMJP);
			pstmt.setString(7, GWMC);
			pstmt.setString(8, XB);
			pstmt.setString(9, SZDW);
			pstmt.setString(10, SZGW);
			pstmt.setString(11, SZBM);
			pstmt.setString(12, MZ);
			pstmt.setString(13, ZT);
			pstmt.setString(14, GMSFHM);
			if (pstmt.executeUpdate() != 1) {
				throw new SQLException("更新RYDAXX失败，GMSFHM = " + GMSFHM );
			}
		}finally{
			pstmt.close();
		}
		
		
	}
	

	public static void SOAQuery(String GMSFHM) throws NamingException, SQLException{
		
		//获取JDBC的连接并开始事务（***注意如果 不能处理异常就要捕获异常）
		Connection conn =	ModelUtils.getConnectionInTransaction("/BJBusWYST/zh/data");
		
		Map<String,Object> mapParam = new HashMap<String,Object>();
		mapParam.put("GMSFHM", GMSFHM);	
		String sql = "select ZH_SOA.* from ZH_SOA ZH_SOA where ZH_SOA.GMSFHM = :GMSFHM";
		Table table = KSQL.select(sql, mapParam, "/BJBusWYST/zh/data", null);
		Iterator<Row> rows = table.iterator();
		while (rows.hasNext()) {
	        Row row = rows.next();
//          String GMSFHM = row.getString("GMSFHM");
            String RYFL = row.getString("RYFL");
            String RYLB = row.getString("RYLB");
            String RYBH = row.getString("RYBH");
            String YGKH = row.getString("YGKH");
            String XM = row.getString("XM");
            String XMJP = row.getString("XMJP");
            String GWMC = row.getString("GWMC");
            String XB = row.getString("XB");
            String SZDW = row.getString("SZDW");
            String SZGW = row.getString("SZGW");
            String SZBM = row.getString("SZBM");
            String MZ = row.getString("MZ");
            String ZT = row.getString("ZT");
            
            updateRYDAXX2 ( conn ,GMSFHM,RYFL, RYLB, RYBH, YGKH, XM,XMJP, GWMC, XB, SZDW, SZGW, SZBM, MZ, ZT);
            
	      }
	}


}