define(function(require) {
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var biz = require('$UI/system/lib/biz');

	var Model = function() {
		this.callParent();
	};
	
	Model.prototype.orderSearchReceiverReceive = function(event){
		this.comp('stbhData').setValue('stbh',event.data);
	};

	//[〈]
	Model.prototype.backBtnClick = function(event) {
		this.comp('orderSearchReceiver').windowEnsure();
	};

	//[查询]
	Model.prototype.searchBtnClick = function(event) {
		var me = this;	
		var mealType, orderStatus, mealTime;
		var orderListData = this.comp('orderListData');
		var searchData = this.comp('searchData');
		var typeData = this.comp('typeData');
		var statusData = this.comp('statusData');
		var mealData = this.comp('mealData');
		if (searchData.val('dateF') === null || searchData.val('dateF') === "") {
			this.comp('okMsg').show({message:'请输入订单日期！'});
			return;	
		}	
		//mealType
		if (typeData.val('CONDIATION') === undefined || typeData.val('CONDIATION') === null || typeData.val('CONDIATION') === '') {
			mealType = '';
		} else {
			mealType = typeData.val('CONDIATION');
		}
		//orderStatus
		if (statusData.val('CONDIATION') === undefined || statusData.val('CONDIATION') === null || statusData.val('CONDIATION') === '') {
			orderStatus = '';
		} else {
			orderStatus = statusData.val('CONDIATION');
		}
		//mealTime
		if (mealData.val('CONDIATION') === undefined || mealData.val('CONDIATION') === null || mealData.val('CONDIATION') === '') {
			mealTime = '';
		} else {
			mealTime = mealData.val('CONDIATION');
		}

		//调用action
		var params = new biz.Request.ActionParam();
		params.setString("mealType", mealType);
		params.setString("orderStatus", orderStatus);
		params.setString("mealTime", mealTime);
		params.setString("stbh", this.comp('stbhData').val('stbh'));
		params.setString("cardId", searchData.val('cardId').trim());
		params.setDate("orderDate", justep.Date.fromString(searchData.val('dateF'), 'yyyy-MM-dd'));
		
//		if (searchData.val('dateT') !== null && searchData.val('dateT') !== "") {
//			params.setDate("dateT", justep.Date.fromString(searchData.val('dateT'), 'yyyy-MM-dd'));
//		}
		params.setString("orderId", searchData.val('orderId').trim());		
		biz.Request.sendBizRequest({
			"context" : this.getContext(),
			"action" : "queryOrderList",
			"parameters" : params,
			"callback" : function(resultData) {
				resultData.ignoreError = false;
				if (resultData.state) {
					if(resultData.response.rows.length === 0){
						me.comp('okMsg').show({message:'没有符合条件的数据！'});
					}else{
						orderListData.loadData(resultData.response);
						//orderListData.refreshData();
						me.comp('contents2').to('orderList');
					}
				} else {
					throw new Error('查询订单信息失败！');
				}
			}
		});
	};
//	Model.prototype.statusDataRefreshCreateParam = function(event) {
//		var mapParam = new biz.Request.MapParam();
//		mapParam.put("CODENAME", "订单状态");
//		event.param.setMap("variables", mapParam);
//	};
//	Model.prototype.mealDataRefreshCreateParam = function(event) {
//		var mapParam = new biz.Request.MapParam();
//		mapParam.put("CODENAME", "餐次");
//		event.param.setMap("variables", mapParam);
//
//	};
//	Model.prototype.typeDataRefreshCreateParam = function(event) {
//		var mapParam = new biz.Request.MapParam();
//		mapParam.put("CODENAME", "用餐类型");
//		event.param.setMap("variables", mapParam);
//	};
	Model.prototype.orderDetailBtnClick = function(event){
		var me = this;
		var row = event.bindingContext.$object;
		var orderDetailData = this.comp('orderDetailData');
		var allDetailData = this.comp('allDetailData');
		var params = new biz.Request.ActionParam();
		params.setString("orderId",row.val('DDBH'));
		
		var cpmc = '';
		biz.Request.sendBizRequest({
		"context":this.getContext(),
		"action":"queryOrderDetail",
		"parameters":params,
		"callback":function(resultData){
				resultData.ignoreError = false;
				if(resultData.state){
					allDetailData.loadData(resultData.response);
					var rowIndex = 0;
					allDetailData.each(function(options){
						var detailRow = options.row;
						cpmc += detailRow.val('CPMC')+ '('+detailRow.val('SL')+'),';
						if(rowIndex === 0)
						{
							rowIndex++;
							orderDetailData.newData({
								index : 0,
								defaultValues : [ {
									"DDBH" : detailRow.val("DDBH"),
									"XDSJ" : detailRow.val("XDSJ"),
									"XM" : detailRow.val("XM"),
									"SCDD" : detailRow.val("SCDD"),
									"XFZE" : '￥' + detailRow.val("XFZE"),
									"DDZT" : detailRow.val("DDZT"),
									"DCCC" : detailRow.val("DCCC"),
									"DDLX" : detailRow.val("DDLX")
								} ]
							});
						}
					});
					if(cpmc.length > 0){
						cpmc = cpmc.substring(0,cpmc.length-1);
					}
					orderDetailData.setValue('CPMC', cpmc);
				}else{					
						me.comp('okMsg').show({message:'取得订单明细失败！'});
				}
			}
		});
	};
	Model.prototype.modelModelConstructDone = function(event){
		this.comp('searchData').setValue('dateF',new Date());		
		this.comp('mealData').setFilter('mealFil', "CODENAME='餐次'");
		this.comp('mealData').refreshData();
		this.comp('statusData').setFilter('statusFil', "CODENAME='订单状态'");	
		this.comp('statusData').refreshData();	
		this.comp('typeData').setFilter('typeFil', "CODENAME='用餐类型'");		
		this.comp('typeData').refreshData();
	};

	Model.prototype.orderListDataCustomRefresh = function(event){
		this.searchBtnClick();
	};

	return Model;
});