 define(function(require) {
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var biz = require("$UI/system/lib/biz");
	require("$UI/BJBusWYST/commonjs/common");

	var Model = function() {
		this.callParent();
	};

	var stbh = '';
	var xph = '';
	var sbzch = '';
	var msgFlg = 1;	
	var kpxxEmpty = 0;
	
	//刷卡后，迁移到"充值"页面
	Model.prototype.rechargeReceiverReceive = function(event){
		stbh = event.data.stbh; 
		xph = event.data.chipNum; 
		sbzch = event.data.sbzch; 
		this.initRecharge();
	};

	// 初始化充值页面
	Model.prototype.initRecharge = function(event) {
		kpxxEmpty = 0;
		var personData = this.comp('personData');
		var params = new biz.Request.ActionParam();
		params.setString("YGKXPXLH", xph);// 5DB7FF31/DAB490A5
		biz.Request.sendBizRequest({
			"context" : this.getContext(),
			"action" : "queryPersonInfo",
			"parameters" : params,
			"callback" : function(resultData) {
				resultData.ignoreError = false;
				if (resultData.state) {
					if(resultData.response.rows.length === 0){
						kpxxEmpty = 1;
					}
					else{						
						personData.loadData(resultData.response);
						personData.refreshData();
					}
				} else {					
					throw new Error("取得员工信息失败！");
				}
			}
		});		
					
		if(kpxxEmpty === 1){
			this.comp('okMsg').show({message:'没有查询到该卡的信息！'});	
		}
	};
	
	//[充值]
	Model.prototype.rechargeBtnClick = function(event) {
		var personData = this.comp('personData');
		var rechangeMoney = document.getElementById(this.getIDByXID('output16')).innerHTML;
		var remainMoney = document.getElementById(this.getIDByXID('output11')).innerHTML.replace('￥', '');
		var type =  /^\d+$/;
		//var type="^[0-9]*[1-9][0-9]*$"; 
        var re = new RegExp(type); 
		
//		if (!IsNum(rechangeMoney)) {
//			alert("请输入数字！");
//		} else if(rechangeMoney.trim().match(re) === null){
//			this.comp('okMsg').show({message:'请输入大于0的正整数！'});
        if(rechangeMoney <= 0){        	
			this.comp('okMsg').show({message:'充值金额必须大于0！'});
        }
        else{
	        if(remainMoney < 0){
				this.comp('okMsg').show({message:'卡片余额不能小于0！'});
			}else {	
				// 更新卡片表的余额
				var kpxxData = this.comp('kpxxData');
				kpxxData.filters.clear();
				kpxxData.setFilter('xphFilter', "YGKXPXLH = '"+ xph +"'");
				kpxxData.refreshData();
				if(kpxxData.getCount()>0){
					kpxxData.setValue('KPYE',remainMoney);
				}
	
				// 给充值流水表赋值
				var czlsData = this.comp('czlsData');
				czlsData.newData({
					defaultValues : [ {
						"YGKXPXLH":xph,
						"SBZCH":sbzch,
						"CZJE":rechangeMoney,
						"STBH":stbh,
						"GMSFHM":personData.val('GMSFHM'),
						"XM":personData.val('XM')
					} ]
				});
				czlsData.saveData();
			}
		}
	};

	// 保存充值流水表之前，保存卡片信息表
	Model.prototype.czlsDataBeforeSave = function(event){
		this.comp('kpxxData').saveData();
	};

	//充值成功
	Model.prototype.czlsDataSaveCommit = function(event){	
		var personData = this.comp('personData');
		this.comp('rechargeSuccMsg').show({message:'充值前金额：￥' + personData.val('KPYE') + '\r\n' + '&nbsp;&nbsp;&nbsp;充值金额：<font style="font-weight:bold;" color = red>￥' + personData.val('CZJE')+'</font>' + '\r\n' + '充值后金额：￥' + personData.val('CHYE')});
	};
	Model.prototype.rechargeSuccMsgOK = function(event){	
		this.comp('rechargeReceiver').windowEnsure();
	};
	
	//充值失败
	Model.prototype.czlsDataSaveError = function(event){
		this.comp('rechargeFailMsg').show();
	};
	
	// 充值时，取得人员信息
	Model.prototype.getPerson1Data = function(event) {	
		var person1Data = this.comp('person1Data');
		var params = new biz.Request.ActionParam();
		params.setString("YGKXPXLH", xph);// 5DB7FF31/DAB490A5

		biz.Request.sendBizRequest({
			"context" : this.getContext(),
			"action" : "queryPersonInfo",
			"parameters" : params,
			"callback" : function(resultData) {
				resultData.ignoreError = false;
				if (resultData.state) {
					person1Data.loadData(resultData.response);
					person1Data.confirmRefresh = false;
					person1Data.refreshData();
				} else {					
					throw new Error("取得员工信息失败！");
				}
			}
		});
	};
	
	//键盘
	Model.prototype.keyCommon = function(event){
		var rechangeMoney = this.comp('personData').val('CZJE').toString();
		var keyValue = parseInt(event.data).toString();
		if(rechangeMoney === '0'){
			this.comp('personData').setValue('CZJE', parseInt(keyValue));
		}
		else{
			this.comp('personData').setValue('CZJE',parseInt(rechangeMoney + keyValue));
		}
	};		
	
	//负数
	Model.prototype.minusBtnClick = function(event){
		this.comp('personData').setValue('CZJE', this.comp('personData').val('CZJE') * (-1));
	};			
	
	//清零
	Model.prototype.clearBtnClick = function(event){
		this.comp('personData').setValue('CZJE', 0);
	};		
	
	//数字键盘-----------begin-----------
	Model.prototype.key1BtnClick = function(event){
		var keyValue =  document.getElementById(this.getIDByXID('key1Btn')).text;
		this.keyCommon({data:keyValue});
	};		
	
	Model.prototype.key2BtnClick = function(event){
		var keyValue =  document.getElementById(this.getIDByXID('key2Btn')).text;
		this.keyCommon({data:keyValue});
	};		
	
	Model.prototype.key3BtnClick = function(event){
		var keyValue =  document.getElementById(this.getIDByXID('key3Btn')).text;
		this.keyCommon({data:keyValue});
	};		
	
	Model.prototype.key4BtnClick = function(event){
		var keyValue =  document.getElementById(this.getIDByXID('key4Btn')).text;
		this.keyCommon({data:keyValue});
	};		
	
	Model.prototype.key5BtnClick = function(event){
		var keyValue =  document.getElementById(this.getIDByXID('key5Btn')).text;
		this.keyCommon({data:keyValue});
	};		
	
	Model.prototype.key6BtnClick = function(event){
		var keyValue =  document.getElementById(this.getIDByXID('key6Btn')).text;
		this.keyCommon({data:keyValue});
	};		
	
	Model.prototype.key7BtnClick = function(event){
		var keyValue =  document.getElementById(this.getIDByXID('key7Btn')).text;
		this.keyCommon({data:keyValue});
	};		
	
	Model.prototype.key8BtnClick = function(event){
		var keyValue =  document.getElementById(this.getIDByXID('key8Btn')).text;
		this.keyCommon({data:keyValue});
	};		
	
	Model.prototype.key9BtnClick = function(event){
		var keyValue =  document.getElementById(this.getIDByXID('key9Btn')).text;
		this.keyCommon({data:keyValue});
	};		
	
	Model.prototype.key0BtnClick = function(event){
		var keyValue =  document.getElementById(this.getIDByXID('key0Btn')).text;
		this.keyCommon({data:keyValue});
	};		
	//数字键盘-----------end-----------	
	
	//[<]
	Model.prototype.backBtnClick = function(event){
		this.comp('rechargeReceiver').windowEnsure();
	};
	
	return Model;
});
