 define(function(require) {
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var biz = require("$UI/system/lib/biz");
	require("$UI/BJBusWYST/commonjs/common");

	var Model = function() {
		this.callParent();
	};

	var stbh = '';
	var mealTime = '';
	var xph = '';
	var msgFlg = 1;	
	var kpxxEmpty = 0;
	
	//接管loginUserData的刷新
	Model.prototype.loginUserDataCustomRefresh = function(event){
		var loginUserData = this.comp('loginUserData');
		biz.Request.sendBizRequest({
			"context" : this.getContext(),
			"action" : "queryLoginUserInfo",
			"callback" : function(resultData) {
				resultData.ignoreError = false;
				if (resultData.state) {
					loginUserData.loadData(resultData.response);
				} else {
					throw new Error("取得食堂信息失败！");
				}
			}
		});
		loginUserData.first();	
		this.comp('titleBar1').set({'title' : loginUserData.val('STMC')});
		stbh = loginUserData.val('STBH');
		msgFlg = 0;
		this.initFood();
		this.comp('contents2').to('foodContent');
	};

//	//从主页面迁移到该页面
//	Model.prototype.indexReceiverReceive = function(event) {
//		stbh = event.data;
//		msgFlg = 0;
//		this.initFood();
//		this.comp('contents2').to('foodContent');
//	};
	
	//初始化紧急售餐页面
	Model.prototype.initFood = function(event) {
		var me = this;
		var foodData = this.comp('foodData');
		//取得餐次
		var params = new biz.Request.ActionParam();
		params.setString("stbh", stbh);
		biz.Request.sendBizRequest({
			"context" : this.getContext(),
			"action" : "getMealTime",
			"parameters" : params,
			"callback" : function(resultData) {
			
				resultData.ignoreError = false;
				if (resultData.state) {
					if(resultData.response === ''){
						if(msgFlg === 0){
							foodData.clear();
							me.comp('okMsg').show({message:'未取到餐次(食堂编号:'+ stbh +')！'});
						}
						msgFlg = 1;
					}else{
						mealTime = resultData.response;					
					}
				} else {
					if(msgFlg === 0){
						foodData.clear();
						throw new Error("取得餐次失败！");
					}
					msgFlg = 1;
				}
			}
		});
		
		if((mealTime === null || mealTime ==='')){
			if(msgFlg === 0){
				foodData.clear();
				this.comp('okMsg').show({message:'现在不是用餐时段！'});
			}
			msgFlg = 1;
			return;
		}

		//刷新紧急售餐一览
		this.comp("foodData").confirmRefresh = false;
		this.comp("list3").refresh(true);	
	};

	// 接管foodData的刷新
	Model.prototype.foodDataCustomRefresh = function(event) {
		var me = this;
		var foodData = this.comp('foodData');
		var params = new biz.Request.ActionParam();
		params.setString("STBH", stbh);
		params.setString("CC", mealTime);

		biz.Request.sendBizRequest({
			"context" : this.getContext(),
			"action" : "queryMenuList",
			"parameters" : params,
			"callback" : function(resultData) {
				resultData.ignoreError = false;
				if (resultData.state) {
					if(resultData.response === undefined){
						if(msgFlg === 0){
							foodData.clear();
							me.comp('okMsg').show({message:'空菜单！'});
						}
						msgFlg = 1;
					}else{
						foodData.loadData(resultData.response);
					}
				} else {
					if(msgFlg === 0){
						foodData.clear();
						throw new Error("取得菜单一览数据失败！");
					}
					msgFlg = 1;
				}
			}
		});
	};
	
	// [退出]
	Model.prototype.logoutBtnClick = function(event) {
		justep.Portal.logout();
	};
	// ======================紧急售餐======================//
	// [+]
	Model.prototype.addCountBtnClick = function(event) {
		var row = event.bindingContext.$object;
		row.val("FS", row.val("FS") + 1);
		var cartData = this.comp('cartData');
		if (cartData.find([ 'fFoodID' ], [ row.val('b') ]).length === 0) {
			cartData.newData({
				index : 0,
				defaultValues : [ {
					"fFoodID" : row.val("b"),
					"STBH" : row.val("STBH"),
					"CPBH" : row.val("CPBH"),
					"CPMC" : row.val("CPMC"),
					"TP" : row.val("TP"),
					"JG" : row.val("JG"),
					"FS" : row.val("FS")
				} ]
			});
		} else {
			cartData.to(row.val('b'));
			cartData.setValue('FS', row.val('FS'));
		}
	};

	// [-]
	Model.prototype.reduceCountBtnClick = function(event) {
		var row = event.bindingContext.$object;
		if(row.val("FS") > 0){
			row.val("FS",  row.val("FS") - 1);					
			var cartData = this.comp('cartData');
			if (row.val('FS') > 0) {
				cartData.to(row.val('b'));
				cartData.setValue('FS', row.val('FS'));
			} else {
				cartData.confirmDelete = false;
				cartData.directDeleteMode = true;
				cartData.to(row.val('b'));
				cartData.deleteData(cartData.getCurrentRow());
			}
		}
	};

	// ======================我的菜单======================//	
	// [扣款]
	Model.prototype.deductBtnClick = function(event) {
		this.comp('swipeCardDialog').open({data:{stbh:stbh}});
	};
	
	// 实际扣款（消费流水表、卡片信息表）
	Model.prototype.deductMoney = function(event) {
		this.getPerson1Data();
		var orderMoney = document.getElementById(this.getIDByXID('output20')).innerHTML.replace('￥', '');
		stbh =event.data.stbh;
		xph =event.data.xph;
		
		if(xph !== null && xph !== '')
		{
			this.initRecharge();
			if(this.comp('personData').val('KPZT') !== '正常'){			
				this.comp('cartData').clear();
				this.comp('okMsg').show({message:'卡片处于停用状态！'});			
			}else{		
				var person1Data = this.comp('person1Data');
				var cartData = this.comp('cartData');
				var loginUserData = this.comp('loginUserData');
				var cpbhAll = '';

				//取得一个新的流水号
				var newLsh = '';
				var params = new biz.Request.ActionParam();
				params.setString('lshPre', loginUserData.val('SBZCH'));
				biz.Request.sendBizRequest({
					"context" : this.getContext(),
					"action" : "getNewLsh",
					"parameters" : params,
					"callback" : function(resultData) {
						resultData.ignoreError = false;
						if (resultData.state) {
							newLsh = resultData.response;
						} else {
							throw new Error("取得流水号失败！");
						}
					}
				});					
		
				// 更新卡片表的余额
				var kpxxData = this.comp('kpxxData');
				kpxxData.filters.clear();
				kpxxData.setFilter('xphFilter', "YGKXPXLH = '" + xph + "'");
				kpxxData.refreshData();
				if(kpxxData.getCount()>0){
					if(kpxxData.val('KPYE') - orderMoney < 0){
						this.comp('okMsg').show({message:'余额不足（余额：<font color=red >￥'+kpxxData.val('KPYE')+'</font>）！'});
						this.comp('cartData').clear();
						return;
					}else{
						person1Data.setValue('KPYE', kpxxData.val('KPYE'));
						person1Data.setValue('CZJE', orderMoney);
						kpxxData.setValue('KPYE',kpxxData.val('KPYE') - orderMoney);
					}
				}
				
				//取得将菜品编号合并成一个字符串
				cartData.each(function(options) {
					cpbhAll += options.row.val('CPBH')+",";
				});
				cpbhAll = cpbhAll.substring(0,cpbhAll.length - 1);
		
				// 费流水表插入一条记录				
				var xflsData = this.comp('xflsData');
				xflsData.newData({
					defaultValues : [ {
						"YGKXPXLH":xph,
						"XFLX":'1',
						"SBZCH":loginUserData.val('SBZCH'),
						"ZDJYLSH":newLsh,
						"XFJE":orderMoney,
						"STBH":stbh,
						"CPBH":cpbhAll,
						"CC":mealTime,
						"GMSFHM":person1Data.val('GMSFHM'),
						"XM":person1Data.val('XM')
					} ]
				});	
			
				// 保存消费流水表
				xflsData.saveData();
			}
		}
	};

	// 保存消费流水表之前，保存订单表、订单详细、卡片信息表
	Model.prototype.xflsDataBeforeSave = function(event) {
		this.comp('kpxxData').saveData();
	};

	// 扣款成功
	Model.prototype.xflsDataSaveCommit = function(event){
		var person1Data = this.comp('person1Data');	
		this.comp('deductSuccMsg').show({message:'扣款前余额：￥' + person1Data.val('KPYE') + '\r\n' + '&nbsp;&nbsp;&nbsp;消费合计：<font style="font-weight:bold;" color = red>￥' + person1Data.val('CZJE')+'</font>' + '\r\n' + '扣款后余额：￥' + person1Data.val('CHYE')});
		this.comp('contents2').to('cartContent');
	};
	Model.prototype.deductSuccMsgOK = function(event){
		this.comp('cartData').clear();
		this.comp('contents2').to('foodContent');
	};

	// 扣款失败
	Model.prototype.xflsDataSaveError = function(event) {
		this.comp('deductFailMsg').show();	
		this.comp('contents2').to('foodContent');
	};

	// [取消]
	Model.prototype.cancelOrderBtnClick = function(event) {
		var cartData = this.comp('cartData');
		var foodData = this.comp('foodData');
		cartData.confirmDelete = false;
		cartData.directDeleteMode = true;
		cartData.deleteAllData();
		
		foodData.each(function(options) {
			options.row.val('FS', 0);
		});
	};
	
	// 刷卡后
	Model.prototype.swipeCardDialogReceive = function(event){
		stbh = event.data.stbh;
		xph = event.data.chipNum;
		this.initFood();
		this.deductMoney({data:{stbh:stbh,xph:xph}});
	};
	
	// 扣款时，取得人员信息
	Model.prototype.getPerson1Data = function(event) {	
		var person1Data = this.comp('person1Data');
		var params = new biz.Request.ActionParam();
		params.setString("YGKXPXLH", xph);// 5DB7FF31/DAB490A5

		biz.Request.sendBizRequest({
			"context" : this.getContext(),
			"action" : "queryPersonInfo",
			"parameters" : params,
			"callback" : function(resultData) {
				resultData.ignoreError = false;
				if (resultData.state) {
					person1Data.loadData(resultData.response);
					person1Data.confirmRefresh = false;
					person1Data.refreshData();
				} else {					
					throw new Error("取得员工信息失败！");
				}
			}
		});
	};	
	
	// 初始化充值页面
	Model.prototype.initRecharge = function(event) {
		kpxxEmpty = 0;
		var personData = this.comp('personData');
		var params = new biz.Request.ActionParam();
		params.setString("YGKXPXLH", xph);// 5DB7FF31/DAB490A5
		biz.Request.sendBizRequest({
			"context" : this.getContext(),
			"action" : "queryPersonInfo",
			"parameters" : params,
			"callback" : function(resultData) {
				resultData.ignoreError = false;
				if (resultData.state) {
					if(resultData.response.rows.length === 0){
						kpxxEmpty = 1;
					}
					else{						
						personData.loadData(resultData.response);
						personData.refreshData();
					}
				} else {					
					throw new Error("取得员工信息失败！");
				}
			}
		});
	};	

	//popMenu	
	Model.prototype.sellFoodContentBtnClick = function(event){
		this.foodDataClearProcess();
		msgFlg = 0;
		this.initFood();
	};
	Model.prototype.listBtnClick = function(event){
		this.comp('listMenu').show();
	};	
	Model.prototype.listBtn2Click = function(event){
		this.comp('listMenu2').show();
	};	
	Model.prototype.listBtn3Click = function(event){
		this.comp('listMenu3').show();
	};	
	Model.prototype.cardSearchBtnClick = function(event){
		this.comp('cardSearchDialog').open();		
	};

	Model.prototype.orderSearchBtnClick = function(event){
		this.comp('orderSearchDialog').open({data:stbh});	
	};	
	
	Model.prototype.cardSearchDialogReceive = function(event){
		this.foodDataClearProcess();
	};
	Model.prototype.orderSearchDialogReceive = function(event){
		this.foodDataClearProcess();
	};
	Model.prototype.foodDataClearProcess = function(event){
		this.initFood();
		this.comp('cartData').clear();
		this.comp('contents2').to('foodContent');
		if(this.comp('orderContentBtn')){
			this.comp('orderContentBtn').removeClass('active');
		}
		if(this.comp('rechargeContentBtn')){
			this.comp('rechargeContentBtn').removeClass('active');
		}
	};
	
	//======================我的订单begin==============
	//刷卡页面（我的订单）
	Model.prototype.orderContentBtnClick = function(event){     
		this.comp('contents2').to('orderContent');	
        this.chipNum1InputHandle();    
	};
	
	//刷卡后，文本框值变化
	Model.prototype.chipNum1DataValueChanged = function(event){
		var chipNum = document.getElementById(this.getIDByXID('chipNum1Input')).value;
		if(chipNum !== '')
		{
			this.comp('chipNum1Input').$domNode.blur();
			//this.comp('myOrderDialog').open({data:{stbh:stbh,chipNum:chipNum}});	
			this.comp('myOrderDialog').open({data:{stbh:stbh,chipNum:'DAB490A5'}});	
		}
	};
	
	//从“我的订单”返回
	Model.prototype.myOrderDialogReceive = function(event){
        this.chipNum1InputHandle();
	};
	
	Model.prototype.chipNum1InputHandle = function(event){
		 this.comp("chipNum1Data").setValue("chipNum", "");
		$(this.getElementByXid("chipNum1Input")).focus();
		//$(this.getElementByXid("chipNum1Input")).val("");
	};
	
	//======================我的订单end==============	

	
	//======================充值begin==============
	//刷卡页面（充值）
	Model.prototype.rechargeContentBtnClick = function(event){	 	 
		this.comp('contents2').to('rechargeContent');	
        this.chipNum2InputHandle();
	};
	
	//刷卡后，文本框值变化
	Model.prototype.chipNum2DataValueChanged = function(event){
		var chipNum = document.getElementById(this.getIDByXID('chipNum2Input')).value;
		if(chipNum !== '')
		{
			var loginUserData = this.comp('loginUserData');
			this.comp('chipNum2Input').$domNode.blur();
			//this.comp('rechargeDialog').open({data:{stbh:stbh,chipNum:chipNum}});	
			this.comp('rechargeDialog').open({data:{stbh:stbh,chipNum:'DAB490A5',sbzch:loginUserData.val('SBZCH')}});
		}		
	};
	
	//从“充值”返回
	Model.prototype.rechargeDialogReceive = function(event){
        this.chipNum2InputHandle();
	};
	
	Model.prototype.chipNum2InputHandle = function(event){
		 this.comp("chipNum2Data").setValue("chipNum", "");
		$(this.getElementByXid("chipNum2Input")).focus();
		//$(this.getElementByXid("chipNum2Input")).val("");
	};	
	//======================充值end==============
	
	return Model;
});
